/***************************************************************************
		            geccogmt.c  -  description  
                   
                             -------------------                 

    start                : October 1999
    GNOME-UPDATE         : Nov 03 1999
    gecco-update         : Feb 15 2000
                                           
    licens               : GPL
    Author               : Martin Oberzalek 
                           leo@checkitmail.at
                           http://members.chello.at/programme_gnome_en.html
    Version              : 0.1

 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/
#include <gnome.h>
#include "geccogmt.h"

#include <stdio.h>

#include "rmmod.xpm"
#include "rmamod.xpm"
#include "rmsmod.xpm"
#include "gmt.xpm"

void *gecco_plugin_init ( int );
int gecco_plugin_run ( GtkWidget * );

static const char *GECCOGMT_AUTHORS[] = { "Martin Oberzalek", NULL };

int ptimer;
char current_module[50];
GtkWidget *window = NULL;

static void QuitApp(gpointer data, guint i, GtkWidget *widget);
void select_func( GtkWidget *clist, gint row, gint i,
		  GdkEventButton *b, gpointer p);
void button_remove( GtkWidget *w, gpointer p);
void button_remove_all( GtkWidget *w, gpointer p);
void button_remove_stack( GtkWidget *w, gpointer p);
gint timer( gpointer data );
int be_superuser();
GtkWidget* CreateWidgetFromXpm(GtkWidget *window, gchar **xpm_data);
int gmt_main( int argc, char *argv[]);

#define APPNAME GECCOGMT_NAME

/************************/
/* GECCO_PLUGIN_INIT	*/
/************************/
/*
 * Register plugin with gecco
 *
 * Returns NULL on failure, a pointer on success.
 */
void *gecco_plugin_init ( command )
     int	command;
{
  if ( !command )
    /*
     * command = 0 -- Plugin should 'register' itself.
     */
    return ( (void *)gecco_plugin_register (
					    GECCOGMT_NAME,
					    GECCOGMT_VERSION,
					    GECCOGMT_FULLNAME,
					    GECCOGMT_AUTHORS,
					    GECCOGMT_DESCRIPTION,
					    NULL,
					    gmt_xpm,
					    TRUE ) );
  else
    {
    /*
     * command != 0 -- Plugin should 'cleanup'.
     */
    /*
     * 'gdtshutdown' should return FALSE (0) upon
     * successful shutdown.
     */
      QuitApp ( NULL, 0, window );
  
      return ( "Success" );
    }

  /*
   * If commands fail, return NULL
   */
  return ( NULL );
}



/************************/
/* GECCO_PLUGIN_RUN	*/
/************************/
/*
 * Execute plugin
 */
int gecco_plugin_run ( display )
     GtkWidget	*display;
{
  /*
   * If display is NULL, then return.
   */
/*  if ( display == NULL )
    return ( FALSE );*/
  
  /*
   * If gdt has already been defined, leave; we don't want
   * more that one copy running at a time.
   *
   * This should not be necessary, as gecco takes care that only
   * one copy can run at a time.
   */
/*  if ( gdt != NULL )
    return ( FALSE );*/
  
/*   gdt = geccodatetime_new ( display );*/
  gmt_main( 0, NULL );

/*  if ( gdt == NULL )
    return ( FALSE );*/
  
  /*
   * Make main window insensitive until everything is set up
   */
  gtk_widget_set_sensitive ( window, FALSE );
  
  /*
   * Make the display visible
   */
  gtk_widget_show_all ( window);
  
  
  
  /*
   * Do your thing here
   */
  
  
  
  /*
   * Make sure display is completely visible before continuing
   */
  while ( gtk_events_pending () )
    gtk_main_iteration ();
  
  /*
   * Done everything; make display sensitive again
   */
  gtk_widget_set_sensitive ( window, TRUE );
  
  return ( TRUE );
}

/****************************************/
int gmt_main( int argc, char *argv[])
{
  GtkWidget *vbox, *hbox, *mlist, *button, *klist, *vscroll, *bbox, *label;
  GtkWidget *bitmap;
  gchar *titles[4] = {N_("Module"),N_("          Size"),N_("Used"),N_("by") };
  gchar *ktitles[2] = {N_("Addres      "),N_("Symbol     ")};
  int be;

#ifdef ENABLE_NLS
  g_print("PACKAGE_LOCALE_DIR: %s\n",PACKAGE_LOCALE_DIR);
  g_print("PACKAGE: %s\n", PACKAGE);
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);
#endif

      
/*  gnome_init( APPNAME, VERSION, argc, argv);*/

  window = gtk_window_new( GTK_WINDOW_TOPLEVEL );
  gtk_window_set_title( GTK_WINDOW( window ), GECCOGMT_NAME );
  gtk_widget_set_usize(window, 400, 400);
  gtk_container_border_width(GTK_CONTAINER(window),2);

  gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		     GTK_SIGNAL_FUNC(QuitApp), NULL);

  vbox = gtk_vbox_new( FALSE, 2);
  gtk_container_add( GTK_CONTAINER( window) , vbox);

  
  //-- mlist
  hbox = gtk_hbox_new( FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0 );

  mlist = gtk_clist_new_with_titles( 4, titles);
  gtk_clist_set_shadow_type(GTK_CLIST(mlist), GTK_SHADOW_IN);
  gtk_clist_set_column_width(GTK_CLIST(mlist), 0, 100);
  gtk_clist_set_column_justification(GTK_CLIST(mlist),
				     1, GTK_JUSTIFY_RIGHT);
  gtk_clist_set_column_justification(GTK_CLIST(mlist),
				     2, GTK_JUSTIFY_RIGHT);

  vscroll = gtk_scrolled_window_new( NULL, NULL);
  gtk_scrolled_window_add_with_viewport( GTK_SCROLLED_WINDOW(vscroll), mlist);
  gtk_box_pack_start(GTK_BOX(hbox), vscroll, TRUE, TRUE, 0);

  //-- klist
  hbox = gtk_hbox_new( FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);

  klist = gtk_clist_new_with_titles( 2, ktitles);
  gtk_clist_set_shadow_type(GTK_CLIST(klist), GTK_SHADOW_IN);
  gtk_clist_set_column_width(GTK_CLIST(klist), 0, 100);


  vscroll = gtk_scrolled_window_new( NULL, NULL);
  gtk_scrolled_window_add_with_viewport( GTK_SCROLLED_WINDOW(vscroll), klist);
  gtk_box_pack_start(GTK_BOX(hbox), vscroll, TRUE, TRUE, 0);


  gtk_signal_connect(GTK_OBJECT(mlist),"select_row",
		     GTK_SIGNAL_FUNC(select_func), (gpointer) klist);

  be = be_superuser();
  if(be == FALSE)
    g_warning(_("%s: Program not started as superuser."),APPNAME); 

  //-- buttons
  hbox = gtk_hbox_new( FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox),hbox, FALSE, TRUE, 0);
  // -- button 1
  button = gtk_button_new();

  bbox = gtk_hbox_new( FALSE, 2);
  gtk_container_add(GTK_CONTAINER(button),bbox);
  bitmap = CreateWidgetFromXpm(button, rmmod_xpm);
  gtk_box_pack_start_defaults(GTK_BOX(bbox),bitmap);
  label = gtk_label_new(_("Remove\nmodule"));
  gtk_box_pack_start_defaults(GTK_BOX(bbox),label);

  if(be==TRUE)
    gtk_signal_connect(GTK_OBJECT(button),"clicked", 
		       GTK_SIGNAL_FUNC(button_remove), NULL);
  else
    gtk_widget_set_sensitive(button, FALSE);
  gtk_box_pack_start(GTK_BOX(hbox),button, TRUE, TRUE, 0);


  //-- button 2
  button = gtk_button_new();

  bbox = gtk_hbox_new( FALSE, 2);
  gtk_container_add(GTK_CONTAINER(button),bbox);
  bitmap = CreateWidgetFromXpm(button, rmamod_xpm);
  gtk_box_pack_start_defaults(GTK_BOX(bbox),bitmap);
  label = gtk_label_new(_("Remove all\nunused\nautocleanable\nmodules"));
  gtk_box_pack_start_defaults(GTK_BOX(bbox),label);

   if(be==TRUE)
     gtk_signal_connect(GTK_OBJECT(button),"clicked", 
			GTK_SIGNAL_FUNC(button_remove_all), NULL);
   else
     gtk_widget_set_sensitive(button, FALSE);
  gtk_box_pack_start(GTK_BOX(hbox),button, TRUE, TRUE, 0);
  // -- button 3
  button = gtk_button_new();

  bbox = gtk_hbox_new( FALSE, 2);
  gtk_container_add(GTK_CONTAINER(button),bbox);
  bitmap = CreateWidgetFromXpm(button, rmsmod_xpm);
  gtk_box_pack_start_defaults(GTK_BOX(bbox),bitmap);
  label = gtk_label_new(_("Remove\nmodule\nstack"));
  gtk_box_pack_start_defaults(GTK_BOX(bbox),label);

  if(be==TRUE)
    gtk_signal_connect(GTK_OBJECT(button),"clicked", 
		       GTK_SIGNAL_FUNC(button_remove_stack), NULL);
  else
    gtk_widget_set_sensitive(button, FALSE);
  gtk_box_pack_start(GTK_BOX(hbox),button, TRUE, TRUE, 0);

  gtk_widget_show_all(window);

  ptimer = gtk_timeout_add(3000, timer,(gpointer) mlist);

  timer( (gpointer) mlist );

  strcpy(current_module,"");

/*  gtk_main(); */

  return 0;
}
/******************************************/
gint timer( gpointer data )
{
  GtkWidget *mlist = (GtkWidget *) data;
  FILE *m_file;
  char readbuf[200];
  char module[50], by[100], ssize[10], sused[10];
  int size, used, row=0, k, i;
  char *modules[4];
  
  gtk_clist_freeze(GTK_CLIST(mlist));

  gtk_clist_clear(GTK_CLIST(mlist));

  if((m_file = fopen(PROC_MODULE_PATH,"rt"))==NULL)
    {
      sprintf(readbuf,"%s unable to load %s",APPNAME, PROC_MODULE_PATH);
      gnome_app_error(GNOME_APP(window),readbuf);
      g_error(readbuf);
    }
  while(fgets(readbuf, sizeof(readbuf), m_file))
    {
      sscanf(readbuf,"%s %d %d %s",module, &size, &used, by);

      for( k=0, i=33; 
	  k<sizeof(by) && i<sizeof(readbuf); 
	  i++, k++)
	by[k]=readbuf[i];

      sprintf(ssize,"%d",size); sprintf(sused,"%d",used);
      modules[0] = module;
      modules[1] = ssize;
      modules[2] = sused;
      modules[3] = by;
    
      gtk_clist_append( (GtkCList *) mlist,(gchar**) modules);
      if(strcmp((char *)current_module, module)==0)
	  gtk_clist_select_row(GTK_CLIST(mlist), row, 0);
      row++;
    }
  fclose(m_file);
  gtk_clist_thaw(GTK_CLIST(mlist));

  return TRUE;
}
/******************************************/
static void QuitApp(gpointer data, guint i, GtkWidget *widget)
{

/*  if( widget )
    gtk_widget_destroy( widget );
  else*/
    if( window != NULL )
      {
/*	g_print("Window: %d\n",window); */
	gtk_widget_hide( window );
	window = NULL;
      }
    if( ptimer != 0 )
      {
/*	g_print("Timer: %d\n",ptimer); */
      	gtk_timeout_remove(ptimer);
	ptimer = 0;
      }
}
/******************************************/
void select_func( GtkWidget *clist, gint row, gint event,
		  GdkEventButton *b, gpointer p)
{
  char *text;
  FILE *pin;
  char readbuf[200], module[50], symbol[100], address[50];
  char *modules[3];
  GtkWidget *klist = (GtkWidget *) p;
  int i;

  gtk_clist_get_text(GTK_CLIST(clist), row, 0, &text);
  strcpy((char *)current_module, text);

  if( (pin = popen("/sbin/ksyms -h","r")) == NULL )
    {
      sprintf(_("%s: failed opening pipe"), APPNAME);
      g_warning(readbuf);
      gnome_app_error(GNOME_APP(window),readbuf);
      return;
    }
  
  gtk_clist_freeze(GTK_CLIST(klist));
  gtk_clist_clear(GTK_CLIST(klist));

  while(fgets(readbuf, sizeof(readbuf), pin))
    {
      sscanf(readbuf,"%s %s %s", address, symbol, module);
      
      for( i=0; i<strlen(module); i++)
	{
	  if(module[i+1]==']')
	    {
	      module[i]=0;
	      break;
	    }
	  module[i]=module[i+1];
	}
 
      if(strcmp((char*)current_module,module)==0)
	{
	  modules[0] = address;
	  modules[1] = symbol;
      
	  gtk_clist_append( (GtkCList *) klist,(gchar**) modules);
	}
    }
  pclose( pin );
  gtk_clist_thaw(GTK_CLIST(klist));
  return;
}
/*******************************************/
void button_remove( GtkWidget *w, gpointer p)
{
  FILE *pin;
  char readbuf[200];
  char befehl[100];

  if(strcmp(current_module,"")==0)
    {
      sprintf(readbuf,_("%s: You must select a module first"),APPNAME);
      g_warning(readbuf);
      gnome_app_error(GNOME_APP(window),readbuf);
      return;
    }
  // 2>&1 -> bring stderr to stdout 
  sprintf(befehl,"/sbin/rmmod %s 2>&1",(char *)current_module);

  if((pin = popen(befehl,"r"))==NULL)
    {
      sprintf(readbuf,_("%s: failed opening pipe"),APPNAME);
      g_warning(readbuf);
      gnome_app_error(GNOME_APP(window),readbuf);
      return;
    }

  while(fgets(readbuf, sizeof(readbuf), pin))
    {
      g_warning(readbuf);
      gnome_app_error(GNOME_APP(window),readbuf);
    }

   pclose(pin);;
}
/******************************************/
void button_remove_all( GtkWidget *w, gpointer p)
{
  FILE *pin;
  char readbuf[200];
  char befehl[100];

  if(strcmp(current_module,"")==0)
    {
      sprintf(readbuf,_("%s: You must select a module first"),APPNAME);
      g_warning(readbuf);
      gnome_app_error(GNOME_APP(window),readbuf);
      return;
    }

  sprintf(befehl,"/sbin/rmmod -a 2>&1");  

  if((pin = popen(befehl,"r"))==NULL)
    {
      sprintf(readbuf,_("%s: failed opening pipe"),APPNAME);
      g_warning(readbuf);
      gnome_app_error(GNOME_APP(window),readbuf);
      return;
    }

  while(fgets(readbuf, sizeof(readbuf), pin))
    {
      g_warning(readbuf);
      gnome_app_error(GNOME_APP(window),readbuf);
    }

   pclose(pin);
}
/********************************************/
void button_remove_stack( GtkWidget *w, gpointer p)
{
  FILE *pin;
  char readbuf[200];
  char befehl[100];

  if(strcmp(current_module,"")==0)
    {
      sprintf(readbuf,_("%s: You must select a module first"),APPNAME);
      g_warning(readbuf);
      gnome_app_error(GNOME_APP(window),readbuf);
      return;
    }

  sprintf(befehl,"/sbin/rmmod -r %s 2>&1",(char *)current_module);

  if((pin = popen(befehl,"r"))==NULL)
    {
      sprintf(readbuf,_("%s: failed opening pipe"),APPNAME);
      g_warning(readbuf);
      gnome_app_error(GNOME_APP(window),readbuf);
      return;
    }

  while(fgets(readbuf, sizeof(readbuf), pin))
    {
      g_warning(readbuf);
      gnome_app_error(GNOME_APP(window),readbuf);
    }

   pclose(pin);
}
/*******************************************/
int be_superuser()
{
  /*
  if( strcmp(g_get_user_name(),"root")==0 ) 
    return TRUE;
  return FALSE;
  */

  /*gecco does this stuff now*/

  return TRUE;
}
/********************************************/

GtkWidget* CreateWidgetFromXpm(GtkWidget *window, gchar **xpm_data)
{
  GdkBitmap *mask, *pixmap_data;
  GtkWidget *pixmap_widget;
  
  // -- Convert the xpm to a gdk-pixmap
  pixmap_data = gdk_pixmap_create_from_xpm_d(window->window, &mask, NULL,
					     (gchar **)xpm_data);
  // -- Convert the pixmap to a widget
  pixmap_widget = gtk_pixmap_new(pixmap_data, mask);
  // -- Show the widget
  gtk_widget_show(pixmap_widget);
  // -- Return it so it can be used
  return (pixmap_widget);
}

